package pl.webnet.JaTrac;

import java.util.*;


class ImageColorMap extends Texture
{
	int pixels[];
	int width, height;
	String filename;


	public ImageColorMap()
	{
		super();
	}

	public ImageColorMap(String filename)
	{
		this.filename = filename;

		initialize();
	}

	public Spectrum updateSpectrum(Spectrum s, Point uv)
	{
		float u = (float)uv.x;
		float v = (float)uv.y;

		int idx = (int)(u * (width - 1) + (int)((1 - v) * (height - 1) + .5) * width);

		return s.create((pixels[idx] >> 16) & 0xff, (pixels[idx] >> 8) & 0xff, pixels[idx] & 0xff);
	}

	public String[] getParamArray()
	{
		final String params[] = {
			"name", "name", "",
			"file", "filename", ""
		};

		return params;
	}
	
	public String[] getAttachArray() { return null; }

	public Object initialize()
	{
		DiskImageIO di = new DiskImageIO(filename);

		pixels = di.pixels;
		width = di.width;
		height = di.height;

		return this;
	}

	public int getProperties()
	{
		return TEXTURE_SPECTRUM;
	}

}
