package pl.webnet.JaTrac;

import javax.imageio.*;
import java.io.*;

/**
 * This is the entry class of JaTrac. Prepares loader, scene, launches
 * the renderer and saves the resulting image.
 * @author: Miloslaw Smyk (thorgal@amiga.com.pl)
 * @version: $Id: JaTrac.java,v 1.5 2001/06/03 01:42:38 thorgal Exp $
 */

class JaTrac
{
	public static void main(String[] args)
	{
		Loader loader = new Loader();
		Scene scene = loader.load(args[0]);

		scene.preprocessSurfaces();
		scene.camera.render(scene);

		try {
			File f = new File("output.png");

			ImageIO.write(scene.camera.screen.toImage(), "png", f);
		} catch (IOException e) { e.printStackTrace(); }
//		MTV.saveImage("output.mtv", scene.camera.screen.toImage());
		System.out.println("\nrays: " + Ray.count);
		System.out.println("triangle intersection tests: " + Triangle.count);
		System.out.println("triangles behind ray's back: " + Triangle.back);
		System.out.println("sphere intersection tests: " + Sphere.count);
	}
}

