package pl.webnet.JaTrac;

import java.util.*;

abstract class Spectrum implements Cloneable, Indexable
{
	public final static int[] white = {255, 255, 255};
	public final static int[] lightGray = {192, 192, 192};
	public final static int[] gray = {128, 128, 128};
	public final static int[] darkGray = {64, 64, 64};
	public final static int[] black = {0, 0, 0};
	public final static int[] red = {255, 0, 0};
	public final static int[] pink = {255, 175, 175};
	public final static int[] orange = {255, 200, 0};
	public final static int[] yellow = {255, 255, 0};
	public final static int[] green = {0, 255, 0};
	public final static int[] magenta = {255, 0, 255};
	public final static int[] cyan = {0, 255, 255};
	public final static int[] blue = {0, 0, 255};
	String name;
	static List index = new Vector();

	public Object clone() throws CloneNotSupportedException
	{
		return super.clone();
	}
	public Spectrum()
	{
	}
	public abstract Spectrum create(double r, double g, double b);
	public abstract Spectrum create(int r, int g, int b);
	public abstract Spectrum create(int[] rgb);
	public abstract Spectrum create(Spectrum spec);
	public abstract void clear();
	public abstract void add(Spectrum spec);
	public abstract void average(Spectrum spec);
	public abstract Spectrum scale(double factor);
	public abstract void interact(Spectrum spec);
	public abstract void interact(double factor, Spectrum spec);
	public abstract void brighten(double factor);
	public abstract void darken(double factor);
	public abstract void MAC(double factor, Spectrum spec);
	public abstract double difference(Spectrum spec);
	public abstract double[] getRGB(double[] rgb);
	public abstract void setRGB(double r, double g, double b);
	public abstract void setRGB(int r, int g, int b);
	public abstract String toString();
	public String getName() { return name; }
}
